.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include comctl32.inc
includelib comctl32.lib

;***************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

example_data proto

LvAddColumns proto hLv:HANDLE,pCols:DWORD
LvAddRow proto hLv:HANDLE,ppLabels:DWORD

;***************************************************************************************************

IDLISTVIEW      equ 10001

WIN_WIDTH       equ 380
WIN_HEIGHT      equ 250

;***************************************************************************************************

.const
AppName     db "ColLstView",0
LvClass     db "SysListView32",0

LvCols      dd OFFSET col01,200,LVCFMT_LEFT
            dd OFFSET col02,150,LVCFMT_LEFT
            dd 0
col01       db "Fruit",0
col02       db "Colour",0

rows        dd OFFSET name01,OFFSET col_green,0
            dd OFFSET name02,OFFSET col_orange,0
            dd OFFSET name03,OFFSET col_yellow,0
            dd OFFSET name04,OFFSET col_red,0
            dd OFFSET name05,OFFSET col_blue,0
            dd 0

name01      db "Apple",0
name02      db "Orange",0
name03      db "Banana",0
name04      db "Strawberry",0
name05      db "Blueberry",0

col_green   db "Green",0
col_orange  db "Orange",0
col_yellow  db "Yellow",0
col_red     db "Red",0
col_blue    db "Blue",0

brg_pal     dd 000bf00h,0007fffh,000ffffh,00000ffh,0ff003fh

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
hListview   HWND        ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;***************************************************************************************************

WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov [wc].cbSize,SIZEOF wc
    mov [wc].style,CS_HREDRAW or CS_VREDRAW
    mov [wc].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [wc].hInstance,eax
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov [wc].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [wc].hCursor,eax
    mov [wc].hbrBackground,COLOR_WINDOW+1
    mov [wc].lpszClassName,OFFSET AppName
    xor eax,eax
    mov [wc].cbClsExtra,eax
    mov [wc].cbWndExtra,eax
    mov [wc].lpszMenuName,eax
    mov [wc].hIconSm,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR AppName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,NULL,hInstance,NULL
    .IF (eax)
        push ebx
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        lea ebx,[msg]
        assume ebx:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, ebx,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, ebx
            invoke DispatchMessage, ebx
        .ENDW
        mov eax,[ebx].wParam
        assume ebx:nothing
        pop ebx
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_NOTIFY --------------------------------------------------------------------------------------
    .IF (eax==WM_NOTIFY)
        mov ecx,lParam
        assume ecx:ptr NMHDR
        mov eax,[ecx].hwndFrom
        mov edx,[ecx].code
        .IF (eax==hListview)
            .IF (edx==NM_CUSTOMDRAW)
                assume ecx:ptr NMLVCUSTOMDRAW
                mov eax,[ecx].nmcd.dwDrawStage
                .IF (eax==CDDS_ITEMPREPAINT)
                    mov eax,[ecx].nmcd.dwItemSpec   ;row index
                    mov edx,[brg_pal + 4*eax]
                    test eax,1
                    mov [ecx].clrText,edx
                    .IF (ZERO?)
                        mov [ecx].clrTextBk,0dededeh
                    .ENDIF
                    mov eax,CDRF_DODEFAULT
                    ret
                .ELSEIF (eax==CDDS_PREPAINT)
                    mov eax,CDRF_NOTIFYITEMDRAW
                    ret
                .ENDIF
            .ENDIF
        .ENDIF
        assume ecx:nothing
;-- WM_SETFOCUS ------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SETFOCUS)
        invoke SetFocus, hListview
;-- WM_SIZE ----------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SIZE)
        mov eax,lParam
        mov edx,eax
        and eax,0ffffh  ;width
        shr edx,16      ;height
        invoke MoveWindow, hListview,0,0,eax,edx,TRUE
;-- WM_CREATE --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke InitCommonControls
        invoke CreateWindowEx, NULL,ADDR LvClass,NULL,WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_SHOWSELALWAYS,0,0,0,0,hwnd,IDLISTVIEW,hInstance,NULL
        mov hListview,eax
        invoke SendMessage, hListview,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT,LVS_EX_FULLROWSELECT
        invoke LvAddColumns, hListview,ADDR LvCols
        invoke example_data
;-- WM_DESTROY -------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke PostQuitMessage, NULL
;-- default ----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

;**********************************************************************************************************

ALIGN 4
example_data proc
    push esi
    mov esi,OFFSET rows
  @@:
    mov eax,[esi]
    test eax,eax
    jz @out
    invoke LvAddRow, hListview,esi
    add esi,(4*3)
    jmp @B
  @out:
    pop esi
    ret
example_data endp

;**********************************************************************************************************

ALIGN 4
LvAddColumns proc hLv:HANDLE,pCols:DWORD
    LOCAL col:LV_COLUMN
    push edi
    push esi
    push ebx
    mov edi,pCols
    lea esi,[col]
    assume esi:ptr LV_COLUMN
    xor ebx,ebx
    mov [esi].imask,LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
  @@:
    mov eax,[edi]       ;pLabel
    test eax,eax
    jz @out
    mov edx,[edi+4]     ;colWidth
    mov ecx,[edi+8]     ;colFmt
    mov [esi].pszText,eax
    mov [esi].lx,edx
    mov [esi].fmt,ecx
    invoke SendMessage, hLv,LVM_INSERTCOLUMN,ebx,esi
    add ebx,1
    add edi,(3*4)
    jmp @B
  @out:
    assume esi:nothing
    pop ebx
    pop esi
    pop edi
    ret
LvAddColumns endp

ALIGN 4
LvAddRow proc hLv:HANDLE,ppLabels:DWORD
    LOCAL item:LV_ITEM
    push edi
    push ebx
    lea edi,[item]
    assume edi:ptr LV_ITEM
    mov ebx,ppLabels
    mov [edi].imask,LVIF_TEXT
    mov [edi].iItem,7fffffffh
    mov [edi].iSubItem,0
    mov eax,[ebx]
    mov [edi].pszText,eax
    invoke SendMessage, hLv,LVM_INSERTITEM,0,edi
    mov [edi].iItem,eax
  @@:
    add ebx,4
    mov eax,[ebx]
    test eax,eax
    jz @out
    mov [edi].pszText,eax
    inc [edi].iSubItem
    invoke SendMessage, hLv,LVM_SETITEM,0,edi
    jmp @B
  @out:
    assume edi:nothing
    pop ebx
    pop edi
    ret
LvAddRow endp

;**********************************************************************************************************

end start
